<?xml version="1.0" encoding="utf-8"?>
<configuration>
  <configSections>
    <sectionGroup name="estat.sri">
      <section name="mapping.store" type="Estat.Sri.MappingStoreRetrieval.Config.MappingStoreConfigSection, Estat.Sri.Utils"/>
    </sectionGroup>
  </configSections>

  <connectionStrings>
    <add name="sqlserver" connectionString="Data Source=sqlserverhost;Initial Catalog=authdb_empty;User Id=mauser;Password=123" providerName="System.Data.SqlClient"/>
    <add name="odp" connectionString="Data Source=oraclehost/XEPDB1;User ID=authdb_empty;Password=123" providerName="Oracle.ManagedDataAccess.Client"/>
    <add name="mysql" connectionString="server=mariadbhost;user id=sdmxuser;password=sdmxpass;database=authdb_empty" providerName="MySql.Data.MySqlClient"/>
  </connectionStrings>
  <appSettings>
    <add key="RetrieverFactory" value="MappingStoreRetrieversFactory"/>
  </appSettings>
 
  <estat.sri>
    <mapping.store>
      <!-- General Database settings apply to both Mapping Store (MSDB) and dissemination databases (DDB) -->
      <!-- Options are: -->
      <!-- provider : The .NET DB Provider name. Mandatory and unique -->
      <!-- subStringCmd : The substring command. Defaults to : SUBSTR -->
      <!-- subStringNeedsLength : Whether the substring command requires to specify the length. Defaults to : false -->
      <!-- parameterMarkerFormat : The named parameter format. Mandatory. -->
      <!-- castToStringFormat : The format text that should be used to cast to string. Defaults to: {0} -->
      <!-- dateCast : The date cast command. Defaults to "" -->
      <!-- subQueryOrderByAllowed : Whether a sub query can have an order by. Defaults to true. -->
      <DatabaseSettings>
        <clear/>
        <add provider="System.Data.SqlClient" subStringCmd="SUBSTRING" subStringNeedsLength="true" parameterMarkerFormat="@{0}" castToStringFormat="CAST({0} AS VARCHAR)" subQueryOrderByAllowed="false"/>
        <add provider="Oracle.ManagedDataAccess.Client" parameterMarkerFormat=":{0}" dateCast="DATE"/>
        <add provider="MySql.Data.MySqlClient" parameterMarkerFormat="@{0}" dateCast="DATE"/>
		<add provider="MySqlConnector" parameterMarkerFormat="@{0}" dateCast="DATE" />
		<!-- DDB only providers -->
        <add provider="org.estat.PcAxis.PcAxisProvider" parameterMarkerFormat="@{0}"/>
        <!-- ODBC options depend on the ODBC driver used. -->
        <add provider="System.Data.Odbc" parameterMarkerFormat="?" subStringCmd="SUBSTRING" subStringNeedsLength="true" castToStringFormat="CAST({0} AS VARCHAR)" subQueryOrderByAllowed="false"/>
      </DatabaseSettings>
      <!-- Dissemination Database (DDB) settings only -->
      <!-- Options are: -->
      <!-- name : The DDB provider name. Mandatory and unique. Must have a corresponding plug-in with IDdbProvider implementation. -->
      <!-- provider : The .NET DB Provider name. -->
      <ddbSettings>
        <clear />
        <add name="SqlServer" provider="System.Data.SqlClient" factoryClass="" dllName="" />
        <add name="Oracle" provider="Oracle.ManagedDataAccess.Client" factoryClass="Oracle.ManagedDataAccess.Client.OracleClientFactory" dllName="Oracle.ManagedDataAccess" />
        <add name="PCAxis" provider="org.estat.PcAxis.PcAxisProvider" factoryClass="Org.Estat.PcAxis.PcAxisProvider" dllName="PcAxis" />
		<add name="MySQL" provider="MySqlConnector" factoryClass="MySqlConnector.MySqlConnectorFactory" dllName="MySqlConnector" />
		<add name="Odbc" provider="System.Data.Odbc" factoryClass="System.Data.Odbc.OdbcFactory" dllName="System.Data.Odbc" />
      </ddbSettings>
      <Dataflow ignoreProductionFlagForData="true" ignoreProductionFlagForStructure="true"/>
    </mapping.store>
  </estat.sri>
  <!--<system.data>
    <DbProviderFactories>
      <remove invariant="Oracle.ManagedDataAccess.Client"/>
      <add name="ODP.NET, Managed Driver" invariant="Oracle.ManagedDataAccess.Client" description="Oracle Data Provider for .NET, Managed Driver" type="Oracle.ManagedDataAccess.Client.OracleClientFactory, Oracle.ManagedDataAccess, Version=4.122.1.0, Culture=neutral, PublicKeyToken=89b483f429c47342"/>
    <remove invariant="MySql.Data.MySqlClient"/><add name="MySQL Data Provider" invariant="MySql.Data.MySqlClient" description=".Net Framework Data Provider for MySQL" type="MySql.Data.MySqlClient.MySqlClientFactory, MySql.Data, Version=6.9.10.0, Culture=neutral, PublicKeyToken=c5687fc88969c44d"/></DbProviderFactories>
  </system.data>-->
  <runtime>
    <assemblyBinding xmlns="urn:schemas-microsoft-com:asm.v1">
      <dependentAssembly>
        <publisherPolicy apply="no"/>
        <assemblyIdentity name="Oracle.ManagedDataAccess" publicKeyToken="89b483f429c47342" culture="neutral"/>
        <bindingRedirect oldVersion="4.121.0.0 - 4.65535.65535.65535" newVersion="4.122.1.0"/>
      </dependentAssembly>
    </assemblyBinding>
  </runtime>
<startup><supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.6.2"/></startup></configuration>
